// - Zack0Wack0 <http://zack0wack0.com>

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
	{
		if(isFile("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs"))
			exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
		else
			exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	}
	
	RTB_registerPref("Voice required","Voice","$Voice::Needed","bool","Server_Voice",0,0,0,"voiceModCallBack");
	RTB_registerPref("Voiced players","Voice","$Voice::Voiced","string 255","Server_Voice","",0,0);
	RTB_registerPref("Admins voiced","Voice","$Voice::Admins","bool","Server_Voice",1,0,0);
}
else
{
	$Voice::Needed = 0;
	$Voice::Voiced = "";
	$Voice::Admins = 1;
}

function serverCmdToggleVoiceMod(%client)
{
	if(%client.isAdmin)
	{
		$Voice::Needed = !$Voice::Needed;
	
		if(!$Voice::Needed)
			messageAll('',"You no longer need to have a \c3Voice\c0 to talk.");
		else
			messageAll('',"You now need to have a \c3Voice\c0 to talk.");
	}
}
function voiceModCallBack(%oldvalue,%newvalue)
{
	if(%newvalue)
		schedule(10,0,"messageAll",'',"You now need to have a \c3Voice\c0 to talk.");
	else
		schedule(10,0,"messageAll",'',"You no longer need to have a \c3Voice\c0 to talk.");
}

package Server_Voice
{
	function serverCmdMessageSent(%client,%message)
	{
		if($Voice::Needed)
		{
			if(%client.BL_ID == getNumKeyID() || %client.isLocalConnection() || (%client.isAdmin && $Voice::Admins))
				return Parent::serverCmdMessageSent(%client,%message);

			%list = strReplace($Voice::Voiced,",","\t");
			
			for(%i=0;%i<getFieldCount(%list);%i++)
			{
				if(getField(%list,%i) == %client.bl_id)
					return Parent::serverCmdMessageSent(%client,%message);
			}
			
			messageClient(%client,'',"You need a \c3Voice\c0 to talk.");
		}
		else
			return Parent::serverCmdMessageSent(%client,%message);
	}
};
activatePackage(Server_Voice);
